from org.codehaus.jettison.json import JSONObject, JSONArray
import sys;
from utilities import Util
from Property import Property

__name_att__ = None;

def _export(objid, parentrespath, name = ""):
  Util.pushPathElement('WASResourceRefBinding')


  if parentrespath == "/":
    parentrespath = "";
  respath = "%(parentrespath)s/%(name)s" % { 'parentrespath':parentrespath, 'name':name }
  if not respath.startswith("/"):
    respath = "/" + respath;

  exportedObject = JSONObject();
  exportedObject.put("name", name);
  exportedObject.put("path", respath);
  exportedObject.put("teamMappings", JSONArray());
  exportedObject.put("inheritTeam", "true");
  exportedObject.put("description", "Discovered WebSphereWASResourceRefBinding");
  exportedObject.put("roleName", "WebSphereWASResourceRefBinding");

  roleProperties = JSONObject();

  Util.addAttributeToJsonIfNotNone(roleProperties, "websphere.wasresourcerefbinding.loginconfigurationname", objid, "loginConfigurationName","WASResourceRefBinding");
  Util.addAttributeToJsonIfNotNone(roleProperties, "websphere.wasresourcerefbinding.jndiname", objid, "jndiName","WASResourceRefBinding");
  exportedObject.put("roleProperties", roleProperties);
  result = { 'object': exportedObject, 'respath':respath }
  extraObjects = [];
  typeFolders = {};
  extraObjects = Property.exportProperties(objid, respath, extraObjects, typeFolders, 'properties',"WASResourceRefBinding");
  if len(extraObjects) != 0:
    result['extraObjects'] = extraObjects;
  Util.popPathElement('WASResourceRefBinding');
  return result;



def create(parentid, jsonobject):
  Util.pushPathElement('WASResourceRefBinding')
  if not jsonobject.has("roleProperties"):
    raise Exception("WASResourceRefBinding resource has no role properties!");

  roleProperties = jsonobject.getJSONObject("roleProperties");

  properties = [];
  Util.addIfNotNone(properties, "loginConfigurationName", roleProperties.optString("websphere.wasresourcerefbinding.loginconfigurationname", None));
  Util.addIfNotNone(properties, "jndiName", roleProperties.optString("websphere.wasresourcerefbinding.jndiname", None));
  print "Creating WASResourceRefBinding with attributes";
  for prop in properties:
    print "%(name)s = %(value)s" % { 'name': prop[0], 'value': prop[1] };
  objid = Util.create("WASResourceRefBinding", parentid, properties);
  if jsonobject.has('children'):
    for curjsonobject in Util.getHighestChildrenWithRole(jsonobject.getJSONArray('children')):
      currole = curjsonobject.getString('roleName');
      propertyObject = Property.createObjIfRole(objid, curjsonobject, currole);
  Util.popPathElement('WASResourceRefBinding');

def update(objid,jsonobject):
  Util.pushPathElement('WASResourceRefBinding')
  if not jsonobject.has("roleProperties"):
    raise Exception("WASResourceRefBinding resource has no role properties!");

  roleProperties = jsonobject.getJSONObject("roleProperties");

  atts = [];
  Util.addAttIfChanged(objid, atts, roleProperties.optString("websphere.wasresourcerefbinding.loginconfigurationname", None), "loginConfigurationName","WASResourceRefBinding");
  Util.addAttIfChanged(objid, atts, roleProperties.optString("websphere.wasresourcerefbinding.jndiname", None), "jndiName","WASResourceRefBinding");
  if len(atts) != 0:
    print "Modifying WASResourceRefBinding with attributes:"
    for prop in atts:
      print "%(name)s = %(value)s" % { 'name': prop[0], 'value': prop[1] };

    Util.modify(objid, atts);
  else:   
    print "WASResourceRefBinding configuration up to date.";

  Property.removeProperties(objid, 'properties',"WASResourceRefBinding");

  if jsonobject.has('children'):
    for curjsonobject in Util.getHighestChildrenWithRole(jsonobject.getJSONArray('children')):
      currole = curjsonobject.getString('roleName');
      propertyObject = Property.createObjIfRole(objid, curjsonobject, currole);
  Util.popPathElement('WASResourceRefBinding');
